﻿using Microsoft.Extensions.Caching.Distributed;
using StackExchange.Redis;

namespace ConsoleApp2.Options;

public enum ColumnType
{
    Blob,
    Text,
    UnDefine,
}

public class DataTransformOptions
{
    public Func<DataRecord, string>? DatabaseFilter { get; set; }

    public Func<string, string>? TransformBinary { get; set; }//Binary转字符串方法

    public Func<DataRecord, IDistributedCache, Task<bool>>? RecordFilter { get; set; }//数据过滤方法
    public Action<DataRecord>? RecordModify { get; set; }//数据修改
    public Func<DataRecord, IDistributedCache, Task<DataRecord?>>? RecordReplace { get; set; }//数据替换
    public Func<DataRecord, IList<DataRecord>?>? RecordAdd { get; set; }//数据替换
    public Action<DataRecord, IDistributedCache>? RecordCache { get; set; }//数据缓存

    /// <summary>
    /// 配置导入数据的特殊列
    /// </summary>
    public Dictionary<string, ColumnType> ColumnTypeConfig { get; set; } = new(); // "table.column" -> type

    public ColumnType GetColumnType(string table, string column)
    {
        return ColumnTypeConfig.GetValueOrDefault($"{table}.{column}", ColumnType.UnDefine);
    }
}